Lparameters oGrid, nColumn

If Vartype(oGrid)="O" and oGrid.BaseClass="Grid"
Else
	If Type('_Screen.ActiveForm')="O"
	Else
		Return .F.
	EndIf
	If Vartype(_Screen.ActiveForm.Grid)="O"
		oGrid=_Screen.ActiveForm.Grid
		nColumn=_Screen.ActiveForm.Grid.ActiveColumn
		If not oGrid.AllowCellSelection
			MessageBox('       ',48,' ')
			Return .F.

		EndIf

	Else
		Return .F.
	EndIf
EndIf

x=CreateObject("ColumnForm")
With x
	.Caption='  "'+oGrid.Columns[nColumn].Header.Caption+'"'
	.Grid=oGrid
	.Column=nColumn

	Local o
	o=oGrid.Columns[nColumn]

	DO case
	Case o.SearchStyle=0
		.lSearch.Enabled=.F.
		.Search.Enabled=.F.
		.Search.SetAll("Enabled",.F.)
	Case o.SearchStyle<0
		.Search.Value=1
	Case o.SearchStyle=2
		.Search.Value=2
	Case o.SearchStyle=3
		.Search.Value=3
	EndCase

	If Empty(o.Tag)
		.lSort.Enabled=.F.
		.Sort.Enabled=.F.
		.Sort.SetAll("Enabled",.F.)
		.Sort1.Visible=.F.
		.Sort2.Visible=.F.
	Else
		DO case
		Case o.Header.SortOrder=0
			.Sort.Value=1
		Case o.Header.SortOrder=1
			.Sort.Value=2
		Case o.Header.SortOrder=2
			.Sort.Value=3
		EndCase
	EndIf

	.Show(1)

EndWith


Define Class ColumnForm as DialogForm
	ControlBox=.F.
	Caption="  "
	Grid=.null.	
	Column=0

	Add Object Search as RadioButton with ;
		Top=15,;
		Left=15

	Add Object Sort as RadioButton with ;
		Top=125,;
		Left=15

	Add Object lSearch as MyLabel with ;
		Top=10,;
		Left=25,;
		BackStyle=1,;
		Width=150,;
		AutoSize=.T.,;
		Caption='      '


	Add Object lSort as MyLabel with ;
		Top=120,;
		Left=25,;
		BackStyle=1,;
		Width=150,;
		AutoSize=.T.,;
		Caption='     '

	Add Object Sort1 as MyImage with ;
		Top=160,;
		Left=25,;
		Picture='Images\Tools\Sort1.bmp'

	Add Object Sort2 as MyImage with ;
		Top=180,;
		Left=25,;
		Picture='Images\Tools\Sort2.bmp'


	Procedure Search.Init
	With this
		DoDefault()
		.Buttons[1].Caption=''
		.Buttons[2].Caption='  '
		.Buttons[3].Caption='   '
			
		.Buttons[1].Top=15
		.Buttons[2].Top=35
		.Buttons[3].Top=55

		.TabIndex=1
	EndWith

	Procedure Sort.Init
	With this
		DoDefault()
		.Buttons[1].Caption=''
		.Buttons[2].Caption=' '
		.Buttons[3].Caption=' '
			
		.Buttons[1].Top=15
		.Buttons[2].Top=35
		.Buttons[3].Top=55
		.TabIndex=2
	EndWith

	Procedure CmdOk.Click
	With thisform
		Local o
		o=.Grid.Columns[.Column]
		If .Search.Enabled
			DO case
			Case .Search.Value=1
				o.SearchStyle=-1
			Case .Search.Value=2
				o.SearchStyle=2
			Case .Search.Value=3
				o.SearchStyle=3
			EndCase
		EndIf
		If .Sort.Enabled
			DO Case
			Case .Sort.Value=1
				o.Header.ShowOrder(0)
			Case .Sort.Value=2
				o.Header.ShowOrder(1)
			Case .Sort.Value=3
				o.Header.ShowOrder(2)
			EndCase
		EndIf
		DoDefault()
	EndWith

EndDefine

Define Class RadioButton as OptionGroup
	FontName=_FontName
	FontSize=8
	Width=375-15-15
	Height=85
	ButtonCount=3
	
	Procedure Init
	With this
		.SetAll("FontName",_FontName)
		.SetAll("FontSize",8)
		.SetAll("AutoSize",.T.)
		.SetAll("Left",35)
	EndWith
	
EndDefine
	
	
	
	
