*
*  
*

#include include/main.h

External Form ORDER
ROOT_OBJECT.AddObject("ORDER","ORDER")


Define Class ORDER as MyDocument
	Name="ORDER"
	Title=' '
	Alias='ORDER'
	FormName='ORDER'
	ListClsID='ORDER.View.1'
	ListCaption='  '
	KeyField='DOCID'
	FaceMask=Bitor(FACE_10,FACE_20)
	
	Procedure Default
	With this.record
		.OwnerID=GetDefault("Common","Owner","")
		.Date=Date()
		.Number=GetNewDocumentNumber(this.alias,this.record)
		.Nds=GetDefault("Common","NDS",0)
		.Tax=GetDefault("Common","Tax",0)

		.CashType=TYPE_CASH
	
	EndWith 
	
	Procedure Tested
	With this.record
		If Empty(.Date)
			MessageBox("   .",64,this.title)
			Return .f.
		EndIf
		If Not CheckDocumentNumber(this.Alias,this.Record,.T.)
			MessageBox("  ",64,this.Title)
			Return .f.
		EndIf
		If Empty(.Number)
			MessageBox("   .",64,this.title)
			Return .f.
		EndIf
		If Empty(.Name)
			MessageBox("  .",64,this.title)
			Return .f.
		EndIf
		If Empty(.Total)
			MessageBox("    ",64,this.title)
			Return .f.
		EndIf
	EndWith 

	Procedure Grid(oGrid)
	With oGrid
		.AddColumn(1,'Date','',,'Date')
		.AddColumn(2,'Number','',_PIC_NUMBER,'number')
		.AddColumn(3,'(Name)','',3,'name')
		.AddColumn(4,'Total','',_PIC_TOTAL)
		.AddColumn(5,'CashType','')
		With .Columns[5]
			.RemoveObject("Text")
			.AddObject("CboCashType","CboCashType")
			.CurrentControl="CboCashType"
			.CboCashType.SpecialEffect=1
			.CboCashType.BorderStyle=0
			.Enabled=.F.
			.Sparse=.F.
		EndWith
		.Summary="total"
	EndWith

	Procedure ShortCutMenu(nColumnIndex)

	Procedure Calculate
	With This
		With .Record
			If Not Empty(.Tax)
				.TaxSum=Round(.Total*.Tax/(100+.Tax),_Tax_Round)
			EndIf
			If Not Empty(.Nds)
				.NdsSum=Round((.Total-.TaxSum)*.Nds/(100+.Nds),_Tax_Round)
			EndIf
			.Summa=.Total-.TaxSum-.NdsSum
		EndWith
	EndWith


EndDefine

