*      
*
* RegREAD
*



#include reg.h

lParameters m.cParam, cDesired

DECLARE Integer RegOpenKey IN Win32API ;
		Integer nHKey, String @cSubKey, Integer @nResult

DECLARE Integer RegCloseKey IN Win32API ;
		Integer nHKey

DECLARE Integer RegQueryValueEx IN Win32API ;
		Integer nHKey, String lpszValueName, Integer dwReserved,;
		Integer @lpdwType, String @lpbData, Integer @lpcbData


Local nKey,cKey,cDeired, ntype, buf, buflen, ret, cString

nKey=0
cKey=Substr(m.cParam,1,At('\',m.cParam)-1)
Ret=cDesired
do case
Case cKey='HKCR'
	nKey=HKEY_CLASSES_ROOT
Case cKey='HKCU'
	nKey=HKEY_CURRENT_USER
Case cKey='HKLM'
	nKey=HKEY_LOCAL_MACHINE
Case cKey='HKU'
	nKey=HKEY_USERS
Case cKey='HKCC'
	nKey=HKEY_CURRENT_CONFIG
Otherwise
	Return Ret
EndCase
cString=Substr(m.cParam,Len(cKey)+2)
hKey=0
If RegOpenKey( nKey, @cString, @hKey ) = ERROR_SUCCESS
	cValue=""
Else
	cValue=SubStr(cString,Rat('\',cString)+1)
	cString=Substr(cString,1,Rat('\',cString)-1)
	If RegOpenKey( nKey, @cString, @hKey ) # 0
		Return Ret
	endif
endif

If not Empty(hKey)
	buf=Replicate(Chr(0),255)
	m.ntype=0
	buflen=Len(buf)
	nErr=RegQueryValueEx(hKey,cValue,0,@ntype,@buf,@buflen)

	If nErr=ERROR_MORE_DATA	&& ERROR_MORE_DATA
		buf=Replicate(Chr(0),buflen)
		nErr=RegQueryValueEx(hKey,cValue,0,@ntype,@buf,@buflen)
	EndIf

	if nErr=ERROR_SUCCESS
		Do case
		Case ntype=4
			Ret=C2B(Left(buf,4))
		Case ntype=5
			Ret=CToBin(Left(buf,4))
		Case InList(ntype,1,2,3,7)
			Ret=Left(buf,buflen-1)
		EndCase
	EndIf 

	RegCloseKey(hKey)
	
	If not Empty(m.cDesired) 
		do case
		Case Vartype(m.cDesired)='N'
			Ret=Val(Ret)
		Case Vartype(m.cDesired)='D'
			Ret=CtoD(Ret)
		Case Vartype(m.cDesired)='T'
			Ret=CtoT(Ret)
		Case Vartype(m.cDesired)='L'
			Ret=not Empty(Ret)
		EndCase
	EndIf

endif
Return Ret
	
Procedure C2B
lparameter m.str
local i, m.ret
m.ret=0
for i=len(m.str) to 1 step -1
    m.ret=BitLShift(m.ret,8)+Asc(SubStr(m.str,i,1))
next
Return int(m.ret)
