
#include include\main.h

*** SYS

Sys(3050,1,64*1024*1024)	&& Buffer memory size
Sys(1104)					&& Purge Cashed memory
Sys(3005,LangID)			&& Add LangID
Sys(3006,LangID)			&& Add LocaleID
Sys(2800,0)					&& Disable Support for invalid
*Sys(2300,1251,1)			&& Add CodePade for ''='' => .F.

#If Version(5)>=800
	Set EngineBehavior 70
#EndIf

**** COMMON

set talk off
set echo off
set bell off
clear macros

*** DATE and TIME

set clock off
set hour to 24
set date to dmy							&& Set date format
set mark to "."							&& set date delimiter
set century on							&& Century ON
set strictdate to 0						&& Ignore incorrect datetime's 					
set seconds off							&& Do not show seconds

*** SYSTEM

set exact off							&& Not full equal
set status time to						&& Reset status bar messages timeout
set message to " "						&& HIde system messsages
set notify off							&& Do not show FoxPro notify messages
set mackey to
set safety off

*** DATA

set collate to 'RUSSIAN'
set deleted on							&& Deleted - excluded
set fullpath on							&& fullpath for files

*** Network

Set Exclusive Off						&& Always network tables use
Set Multilocks  on
set reprocess to 1						&& Set reprocess to 5 times

*** Macros

set mackey to
On Key Label ALT+F10 NOTE

**** Currency

set fweek to 1					&& year begins from 1st January
set fdow to 2					&& week starts from Monday
set currency to " p." 			&& Currency symbol
set currency right				&& Currency right position of numbers
set point to ","				&& Decimal point character
set decimal to 2				&& Default 2 decimal point 

*** More system and DEBUG

set escape off
set view off					&& Hide VIEW window
set echo off
set step off
set dohistory off				&& dohistory OFF
set debug off					&& Hide debug window if exist

set trbetween off				&& no trace between breaks
_THROTTLE=0						&& trace delay


#If Version(5)>=800
	Set Notify Cursor Off
#EndIf


*set resource off

Procedure SysFormat
If SET("SYSFORMAT")="OFF"
	SET CENTURY ON
	SET CURRENCY TO " ."
	SET DATE TO DMY
	SET DECIMALS TO 2
	SET HOURS TO 24
	SET MARK TO "."
	SET POINT TO ","
	SET SEPARATOR TO " "
ENDIF

