*
*  -  
*
*

#include main.h


Lparameters m.obj
If vartype(m.obj) # T_OBJECT
	MessageBox("   .",64,"")
	Return .F.
EndIf

With m.Obj
	If Empty(.ItemID)
		MessageBox("  ",64,.Title)
		Return .F.
	EndIf

	If Vartype(.Form)=T_OBJECT
		.Form.Close()
	EndIf

	Local m.info
	m.info=Info("   ...")

	Select name from Item where Item.ItemId=.ItemID into array tmp
	If _TALLY = 0
		MessageBox("  ",64,.Title)
		Return .F.
	EndIf
	.ItemName=Alltrim(tmp[1])

	If Used(.alias)
		Zap in (.Alias)
	Else
		Create Cursor (.Alias) ;
			(DocID		C(10);
			,Number		i;
			,Date		d;
			,CashType	i;
			,DocType	i;
			,DocName	c(50);
			,TypeOfDoc	c(20);
			,Name		m;
			,InCome		y;
			,InComeSum	y;
			,OutGo		y;
			,OutGoSum	y;
			,Saldo		y;
			,SaldoSum	y;
			,Price		y;
			,Alias		c(10);
			,Object		c(20);
			,SortOrder	i;
			)
	EndIf
	m.saldo=GetItemBalance(.ItemID,.DateMin,.OwnerID)
	Insert into (.Alias) (DocName,Saldo) VALUES (" ",m.saldo)

	****   
	
	Select ;
		Supply.DOCID;
		,Supply.Number;
		,Supply.Date;
		,Supply.CashType;
		,Supply.DocType;
		,'' as DocName ;
		,SupData.Amount as InCome;
		,SupData.Summa as InComeSum;
		,SupData.Price ;
		,Supply.Name ;
		,'SUPPLY' as Alias;
		,'SUPPLY' as Object;
		,1 as SortOrder ;
		from supdata,supply,item ;
		where SupData.ItemID=.ItemID ;
		and Supply.docid=SupData.docid ;
		and Supply.Date between .DateMin and .DateMax ;
		and Supply.OwnerID between .MinOwnerID and .MaxOwnerID ;
		and Supply.CustID between .MinCustID and .MaxCustID ;
		and Item.ItemID=SupData.ItemID ;
		and not Supply.Archive ;
		order by 3,2;
		into cursor _
		
	Select (.Alias)
	Append From Dbf("_")
	
	****  
	
	Select ;
		Invoice.DOCID;
		,Invoice.Number;
		,Invoice.Date;
		,Invoice.CashType;
		,Invoice.DocType;
		,'' as DocName ;
		,InvData.Amount as OutGo;
		,InvData.Summa as Summa ;
		,InvData.Price ;
		,Invoice.Name ;
		,'INVOICE' as Alias;
		,'INVOICE' as Object;
		,3 as SortOrder ;
		from InvData,Invoice, Item ;
		where InvData.ItemID=.ItemID ;
		and Invoice.DocID=InvData.DocID ;
		and Invoice.Date between .DateMin and .DateMax ;
		and Invoice.OwnerID between .MinOwnerID and .MaxOwnerID ;
		and Invoice.CustID between .MinCustID and .MaxCustID ;
		and not Invoice.Archive ;
		and Item.ItemID=InvData.ItemID ;
		order by 3,2;
		into cursor _
		
	Select (.Alias)
	Append From Dbf("_")

	Select * from (.Alias) order by date,SortOrder,Number into cursor _

	USE in Select(.Alias)
	USE Dbf("_") Again Exclusive In 0 Alias (.Alias)
	USE in _

	Local m.suptype, m.invtype
	m.suptype=CreateObject("SUPDOCTYPE")
	m.invtype=CreateObject("INVDOCTYPE")
	
	Select (.Alias)
	Go Top
	m.Saldo=Saldo
	Scan All
		DO case
		Case Alias='SUPPLY'
			If DocType=SUP_RESERVED
			Else
				m.Saldo=m.Saldo+InCome-OutGo
			EndIf
		Case Alias='INVOICE'
			If DocType=INV_RESERVED
			Else
				m.Saldo=m.Saldo+InCome-OutGo
			EndIf
		Other
			m.Saldo=m.Saldo+InCome-OutGo
		EndCase
		Replace Saldo with m.Saldo

		DO case
		Case alias='INVOICE'
			m.invtype.value=DOCTYPE
			m.text=m.invtype.DisplayValue
		Case alias='SUPPLY'
			m.suptype.value=DOCTYPE
			m.text=m.suptype.DisplayValue
		Otherwise
			m.Text=""
		EndCase
		Replace TypeOfDoc with m.Text
	EndScan

	Select sum(income) from (.Alias) where not DOCTYPE=SUP_RESERVED ;
		into  array tmp

	m.in=Iif(_TALLY=0,0,TMP[1])

	Select sum(outgo) from (.Alias) where not DOCTYPE=INV_RESERVED ;
		into  array tmp

	m.out=Iif(_TALLY=0,0,TMP[1])

	Insert into (.alias) (DocName,Income,OutGo,Saldo) Values ;
	('',m.in,m.out,m.saldo)

	Go top

	If Not .Direct
		.Show()
	EndIf
	
EndWith


Define Class ItemCard as Report
	Title=' '
	Text=" "
	Alias="ItemCard"
	ClsID="ItemCard.View.1"
	FormFile="ItemCard"
	Direct=.F.
	ItemName=""	

	Procedure Selection
	With this
		If DoDefault()
			DO ItemCard with this
		EndIf
	EndWith

	Procedure Browse(oGrid)
	With oGrid
		.Parent.Caption=this.Title+' "'+this.ItemName+'"'

		.AddColumn(1,"Date","")
		.AddColumn(2,"Number","",'@Z'+_PIC_NUMBER)
		.AddColumn(3,"DocName","")
		.AddColumn(4,"TypeOfDoc","")
		.AddColumn(5,"(Name)","",3)
		.AddColumn(6,"Price","","@Z "+_PIC_PRICE)
		.AddColumn(7,"InCome","","@Z "+_PIC_AMOUNT)
		.AddColumn(8,"InComeSum"," ","@Z "+_PIC_SUMMA)
		.AddColumn(9,"OutGo","","@Z "+_PIC_AMOUNT)
		.AddColumn(10,"OutGoSum"," ","@Z "+_PIC_SUMMA)
		.AddColumn(11,"Saldo","","@Z "+_PIC_SUMMA)

		.SetAll("DynamicFontBold","iif(DocName=[],.T.,.F.)","MyColumn")

	EndWith

	Procedure Open
	With this
		Local m.docid, m.object
		m.docid=docid
		If not Empty(m.docid)
			m.object=Alltrim(object)
			If not Empty(m.object)
				Return Evaluate("oKernel."+m.Object+".Open(["+m.docid+"])")
			EndIf			
		EndIf
	EndWith
	
EndDefine
	

