*
*  - 
*
*

#include main.h


Lparameters m.obj
If vartype(m.obj) # T_OBJECT
	MessageBox("   .",64,"")
	Return .F.
EndIf

With m.Obj
	If Vartype(.Form)=T_OBJECT
		.Form.Close()
	EndIf

	Local m.info
	m.info=Info("    ...")

	If Used(.alias)
		Zap in (.Alias)
	Else
		Create Cursor (.Alias) ;
			(ItemID		C(10);
			,Batch		i;
			,Name		m;
			,Unit		c(20);
			,Packing	c(20);
			,Price		y;
			,Remainder	y;
			)
	EndIf

	****   
	
	Select ;
		 SupData.ItemID ;
		,SupData.Batch ;
		,Sum(SupData.Amount) as InCome ;
		,$0 as OutGo ;
		from supdata,supply,item ;
		where Supply.docid=SupData.docid ;
		and Supply.Date <= .DateMax ;
		and Supply.OwnerID between .MinOwnerID and .MaxOwnerID ;
		and Supply.CustID between .MinCustID and .MaxCustID ;
		and Item.ItemID=SupData.ItemID ;
		and item.ItemID between .MinItemID and .MaxItemID ;
		and Item.GroupID between .MinGroupID and .MaxGroupId ;
		and not Supply.Archive ;
		and not Supply.DocType=SUP_RESERVED;
		and not Item.Unlimited ;
		group by 1,2 ;
	Union All Select ;
		InvData.ItemID;
		,InvData.Batch ;
		,$0 as InCome ;
		,Sum(InvData.Amount) as OutGo ;
		from InvData,Invoice, Item ;
		where Invoice.DocID=InvData.DocID ;
		and Invoice.Date between .DateMin and .DateMax ;
		and Invoice.OwnerID between .MinOwnerID and .MaxOwnerID ;
		and Invoice.CustID between .MinCustID and .MaxCustID ;
		and not Invoice.Archive ;
		and Item.ItemID=InvData.ItemID ;
		and Item.ItemID between .MinItemID and .MaxItemID ;
		and Item.GroupID between .MinGroupID and .MaxGroupID ;
		and not Item.Unlimited ;
		group by 1,2 ;
		into cursor _
		
	Select ;
		Item.*;
		,Sum(_.InCome-_.OutGo) as Remainder;
		,SupData.Price as BatchPrice ;
		,SupData.Ship as Ship ;
		,SupData.Batch ;
		,Sum((_.InCome-_.OutGo)*SupData.Price) as Summa ;
		,Part.Name as GroupName ;
		,Supply.Date as SupplyDate ;
		,Supply.DocID ;
		,Padr(Part.Name,50) as PartSort ;
		,Padr(Item.Name,50) as ItemSort ;
	from _,Item, Part, SupData, Supply ;
		where Item.ItemID=_.ItemID ;
		and Part.GroupID=Item.GroupID ;
		and SupData.Batch=_.Batch ;
		and Supply.DocID=SupData.DocID ;
		group By Item.ItemID, _.Batch ;
		order by PartSort,ItemSort ;
		into cursor _

	USE in Select(.Alias)
	USE Dbf("_") Again Exclusive In 0 Alias (.Alias)
	USE in _

	Select sum(Summa) from (.Alias) into  array tmp
	m.Summa=Iif(_TALLY=0,0,TMP[1])
	
	Insert into (.alias) (Name,Summa) Values ;
	('',m.summa)

	Select (.Alias)
	Go top

	If Not .Direct
		.Show()
	EndIf
	
EndWith


Define Class Lefts as Report
	Title=''
	Text="   "
	Alias="Lefts"
	ClsID="Lefts.View.1"
	FormFile="Lefts"
	Direct=.F.
	

	Procedure Selection
	With this
		If DoDefault()
			DO Lefts with this
		EndIf
	EndWith

	Procedure Browse(oGrid)
	With oGrid
		.AddColumn(1,"(GroupName)","",2)
		.AddColumn(2,"(Name)","",3)
		.AddColumn(3,"Unit","..")
		.AddColumn(4,"Packing","")
		.AddColumn(5,"Batchprice","","@Z "+_PIC_PRICE)
		.AddColumn(6,"Remainder","","@Z "+_PIC_AMOUNT)
		.AddColumn(7,"Summa"," ","@Z "+_PIC_SUMMA)
		.AddColumn(8,"SupplyDate"," ")
		
		.SetAll("DynamicFontBold","iif(Name=[],.T.,.F.)","MyColumn")

	EndWith

	Procedure Open
	With this
		Local m.docid, m.object
		m.docid=docid
		If not Empty(m.docid)
			ROOT_OBJECT.Supply.Open(m.docid)
		EndIf
	EndWith
	
EndDefine
	

