*
* WinInet.DLL some defines
* <cut from FTP.PRG>
*
*   .. 2000
*

#DEFINE ERROR_SUCCESS							  0
#DEFINE ERROR_FILE_NOT_FOUND             		  2
#DEFINE ERROR_PATH_NOT_FOUND             		  3
#DEFINE ERROR_ACCESS_DENIED              		  5
#DEFINE ERROR_INVALID_HANDLE             		  6
#DEFINE ERROR_NO_MORE_FILES						  18
#DEFINE ERROR_FILE_EXISTS                		  80
#DEFINE ERROR_INVALID_PARAMETER          		  87


#DEFINE ERROR_INTERNET_BASE 					  12000

#DEFINE ERROR_INTERNET_OUT_OF_HANDLES             (ERROR_INTERNET_BASE + 1)
#DEFINE ERROR_INTERNET_TIMEOUT                    (ERROR_INTERNET_BASE + 2)
#DEFINE ERROR_INTERNET_EXTENDED_ERROR             (ERROR_INTERNET_BASE + 3)
#DEFINE ERROR_INTERNET_INTERNAL_ERROR             (ERROR_INTERNET_BASE + 4)
#DEFINE ERROR_INTERNET_INVALID_URL                (ERROR_INTERNET_BASE + 5)
#DEFINE ERROR_INTERNET_UNRECOGNIZED_SCHEME        (ERROR_INTERNET_BASE + 6)
#DEFINE ERROR_INTERNET_NAME_NOT_RESOLVED          (ERROR_INTERNET_BASE + 7)
#DEFINE ERROR_INTERNET_PROTOCOL_NOT_FOUND         (ERROR_INTERNET_BASE + 8)
#DEFINE ERROR_INTERNET_INVALID_OPTION             (ERROR_INTERNET_BASE + 9)
#DEFINE ERROR_INTERNET_BAD_OPTION_LENGTH          (ERROR_INTERNET_BASE + 10)
#DEFINE ERROR_INTERNET_OPTION_NOT_SETTABLE        (ERROR_INTERNET_BASE + 11)
#DEFINE ERROR_INTERNET_SHUTDOWN                   (ERROR_INTERNET_BASE + 12)
#DEFINE ERROR_INTERNET_INCORRECT_USER_NAME        (ERROR_INTERNET_BASE + 13)
#DEFINE ERROR_INTERNET_INCORRECT_PASSWORD         (ERROR_INTERNET_BASE + 14)
#DEFINE ERROR_INTERNET_LOGIN_FAILURE              (ERROR_INTERNET_BASE + 15)
#DEFINE ERROR_INTERNET_INVALID_OPERATION          (ERROR_INTERNET_BASE + 16)
#DEFINE ERROR_INTERNET_OPERATION_CANCELLED        (ERROR_INTERNET_BASE + 17)
#DEFINE ERROR_INTERNET_INCORRECT_HANDLE_TYPE      (ERROR_INTERNET_BASE + 18)
#DEFINE ERROR_INTERNET_INCORRECT_HANDLE_STATE     (ERROR_INTERNET_BASE + 19)
#DEFINE ERROR_INTERNET_NOT_PROXY_REQUEST          (ERROR_INTERNET_BASE + 20)
#DEFINE ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND   (ERROR_INTERNET_BASE + 21)
#DEFINE ERROR_INTERNET_BAD_REGISTRY_PARAMETER     (ERROR_INTERNET_BASE + 22)
#DEFINE ERROR_INTERNET_NO_DIRECT_ACCESS           (ERROR_INTERNET_BASE + 23)
#DEFINE ERROR_INTERNET_NO_CONTEXT                 (ERROR_INTERNET_BASE + 24)
#DEFINE ERROR_INTERNET_NO_CALLBACK                (ERROR_INTERNET_BASE + 25)
#DEFINE ERROR_INTERNET_REQUEST_PENDING            (ERROR_INTERNET_BASE + 26)
#DEFINE ERROR_INTERNET_INCORRECT_FORMAT           (ERROR_INTERNET_BASE + 27)
#DEFINE ERROR_INTERNET_ITEM_NOT_FOUND             (ERROR_INTERNET_BASE + 28)
#DEFINE ERROR_INTERNET_CANNOT_CONNECT             (ERROR_INTERNET_BASE + 29)
#DEFINE ERROR_INTERNET_CONNECTION_ABORTED         (ERROR_INTERNET_BASE + 30)
#DEFINE ERROR_INTERNET_CONNECTION_RESET           (ERROR_INTERNET_BASE + 31)
#DEFINE ERROR_INTERNET_FORCE_RETRY                (ERROR_INTERNET_BASE + 32)
#DEFINE ERROR_INTERNET_INVALID_PROXY_REQUEST      (ERROR_INTERNET_BASE + 33)
#DEFINE ERROR_INTERNET_NEED_UI                    (ERROR_INTERNET_BASE + 34)

#DEFINE ERROR_INTERNET_HANDLE_EXISTS              (ERROR_INTERNET_BASE + 36)
#DEFINE ERROR_INTERNET_SEC_CERT_DATE_INVALID      (ERROR_INTERNET_BASE + 37)
#DEFINE ERROR_INTERNET_SEC_CERT_CN_INVALID        (ERROR_INTERNET_BASE + 38)
#DEFINE ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR     (ERROR_INTERNET_BASE + 39)
#DEFINE ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR     (ERROR_INTERNET_BASE + 40)
#DEFINE ERROR_INTERNET_MIXED_SECURITY             (ERROR_INTERNET_BASE + 41)
#DEFINE ERROR_INTERNET_CHG_POST_IS_NON_SECURE     (ERROR_INTERNET_BASE + 42)
#DEFINE ERROR_INTERNET_POST_IS_NON_SECURE         (ERROR_INTERNET_BASE + 43)
#DEFINE ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED    (ERROR_INTERNET_BASE + 44)
#DEFINE ERROR_INTERNET_INVALID_CA                 (ERROR_INTERNET_BASE + 45)
#DEFINE ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP      (ERROR_INTERNET_BASE + 46)
#DEFINE ERROR_INTERNET_ASYNC_THREAD_FAILED        (ERROR_INTERNET_BASE + 47)
#DEFINE ERROR_INTERNET_REDIRECT_SCHEME_CHANGE     (ERROR_INTERNET_BASE + 48)
#DEFINE ERROR_INTERNET_DIALOG_PENDING             (ERROR_INTERNET_BASE + 49)
#DEFINE ERROR_INTERNET_RETRY_DIALOG               (ERROR_INTERNET_BASE + 50)
#DEFINE ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR    (ERROR_INTERNET_BASE + 52)
#DEFINE ERROR_INTERNET_INSERT_CDROM               (ERROR_INTERNET_BASE + 53)


*
* FTP API errors
*

#DEFINE FTP_TRANSFER_IN_PROGRESS            	  (ERROR_INTERNET_BASE + 110)
#DEFINE FTP_DROPPED                         	  (ERROR_INTERNET_BASE + 111)
#DEFINE FTP_NO_PASSIVE_MODE                       (ERROR_INTERNET_BASE + 112)


*
* additional Internet API error codes
*

#DEFINE ERROR_INTERNET_SECURITY_CHANNEL_ERROR     (ERROR_INTERNET_BASE + 157)
#DEFINE ERROR_INTERNET_UNABLE_TO_CACHE_FILE       (ERROR_INTERNET_BASE + 158)
#DEFINE ERROR_INTERNET_TCPIP_NOT_INSTALLED        (ERROR_INTERNET_BASE + 159)
#DEFINE ERROR_INTERNET_DISCONNECTED               (ERROR_INTERNET_BASE + 163)
#DEFINE ERROR_INTERNET_SERVER_UNREACHABLE         (ERROR_INTERNET_BASE + 164)
#DEFINE ERROR_INTERNET_PROXY_SERVER_UNREACHABLE   (ERROR_INTERNET_BASE + 165)

#DEFINE ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT      (ERROR_INTERNET_BASE + 166)
#DEFINE ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT  (ERROR_INTERNET_BASE + 167)
#DEFINE ERROR_INTERNET_SEC_INVALID_CERT    		  (ERROR_INTERNET_BASE + 169)
#DEFINE ERROR_INTERNET_SEC_CERT_REVOKED    		  (ERROR_INTERNET_BASE + 170)

*
* handle types
*

#DEFINE ERROR_INTERNET_HANDLE_TYPE_INTERNET              1
#DEFINE ERROR_INTERNET_HANDLE_TYPE_CONNECT_FTP           2
#DEFINE ERROR_INTERNET_HANDLE_TYPE_CONNECT_GOPHER        3
#DEFINE ERROR_INTERNET_HANDLE_TYPE_CONNECT_HTTP          4
#DEFINE ERROR_INTERNET_HANDLE_TYPE_FTP_FIND              5
#DEFINE ERROR_INTERNET_HANDLE_TYPE_FTP_FIND_HTML         6
#DEFINE ERROR_INTERNET_HANDLE_TYPE_FTP_FILE              7
#DEFINE ERROR_INTERNET_HANDLE_TYPE_FTP_FILE_HTML         8
#DEFINE ERROR_INTERNET_HANDLE_TYPE_GOPHER_FIND           9
#DEFINE ERROR_INTERNET_HANDLE_TYPE_GOPHER_FIND_HTML      10
#DEFINE ERROR_INTERNET_HANDLE_TYPE_GOPHER_FILE           11
#DEFINE ERROR_INTERNET_HANDLE_TYPE_GOPHER_FILE_HTML      12
#DEFINE ERROR_INTERNET_HANDLE_TYPE_HTTP_REQUEST          13



#DEFINE BYTE_1											 1
#DEFINE BYTE_2                                           256
#DEFINE BYTE_3                                           65536
#DEFINE BYTE_4                                           16777216
#DEFINE MAXDWORD										 4294967295

*
* File Caching Flags
*

#DEFINE INTERNET_FLAG_DONT_CACHE						 67108864
#DEFINE INTERNET_FLAG_HYPERLINK							 1024
#DEFINE INTERNET_FLAG_MAKE_PERSISTENT					 33554432
#DEFINE INTERNET_FLAG_MUST_CACHE_REQUEST			     16
#DEFINE INTERNET_FLAG_RELOAD							 2147483648
#DEFINE INTERNET_FLAG_NO_CACHE_WRITE				     67108864
#DEFINE INTERNET_FLAG_RESYNCHRONIZE						 2048

*
* File Attributes
*

#DEFINE FILE_ATTRIBUTE_READONLY         				 1
#DEFINE FILE_ATTRIBUTE_HIDDEN           				 2
#DEFINE FILE_ATTRIBUTE_SYSTEM              				 4
#DEFINE FILE_ATTRIBUTE_DIRECTORY        				 16
#DEFINE FILE_ATTRIBUTE_ARCHIVE          	   			 32
#DEFINE FILE_ATTRIBUTE_ENCRYPTED        				 64
#DEFINE FILE_ATTRIBUTE_NORMAL           				 128
#DEFINE FILE_ATTRIBUTE_TEMPORARY        				 256
#DEFINE FILE_ATTRIBUTE_SPARSE_FILE      				 512
#DEFINE FILE_ATTRIBUTE_REPARSE_POINT    				 1024
#DEFINE FILE_ATTRIBUTE_COMPRESSED       				 2048
#DEFINE FILE_ATTRIBUTE_OFFLINE          				 4096


#DEFINE BIT_ATTRIBUTE_READONLY         				 	 0
#DEFINE BIT_ATTRIBUTE_HIDDEN           				 	 1
#DEFINE BIT_ATTRIBUTE_SYSTEM              				 2
#DEFINE BIT_ATTRIBUTE_DIRECTORY        				 	 4
#DEFINE BIT_ATTRIBUTE_ARCHIVE          	   			 	 5
#DEFINE BIT_ATTRIBUTE_ENCRYPTED							 6
#DEFINE BIT_ATTRIBUTE_NORMAL           				 	 7
#DEFINE BIT_ATTRIBUTE_TEMPORARY        				 	 8
#DEFINE BIT_ATTRIBUTE_SPARSE_FILE						 9
#DEFINE BIT_ATTRIBUTE_REPARSE_POINT                      10
#DEFINE BIT_ATTRIBUTE_COMPRESSED       				 	 11
#DEFINE BIT_ATTRIBUTE_OFFLINE          				 	 12


* Flags for InternetAutodial
#DEFINE INTERNET_AUTODIAL_FORCE_ONLINE          	     1
#DEFINE INTERNET_AUTODIAL_FORCE_UNATTENDED      	     2
#DEFINE INTERNET_AUTODIAL_FAILIFSECURITYCHECK   	     4

*
* FTP
*TYPE

#DEFINE FTP_TRANSFER_TYPE_UNKNOWN   			         0
#DEFINE FTP_TRANSFER_TYPE_ASCII     			         1
#DEFINE FTP_TRANSFER_TYPE_BINARY    			         2

* Flags for InternetGetConnectedState
#DEFINE INTERNET_CONNECTION_MODEM                        1
#DEFINE INTERNET_CONNECTION_LAN                          2
#DEFINE INTERNET_CONNECTION_PROXY                        4
#DEFINE INTERNET_CONNECTION_MODEM_BUSY                   8


#DEFINE FTP_TRANSFER_TYPE_MASK      			         3  && (FTP_TRANSFER_TYPE_ASCII | FTP_TRANSFER_TYPE_BINARY)

*
* Internet Variables

#DEFINE INTERNET_DEFAULT FTP_PORT			   	         21
#DEFINE INTERNET_SERVICE_FTP				             1
#DEFINE INTERNET_OPEN_TYPE_DIRECT			             1
#DEFINE INTERNET_FLAG_PASSIVE							 0x08000000

#DEFINE INTERNET_CONNECT_FLAG_PASSIVE

#DEFINE cNULL									         CHR(0)
#DEFINE MAX_PATH 								         260
