*:********************************************************************
*:
*: Procedure file :CALENDAR.PRG
*:
*: Contents :
*: 
*: 		Class     Calendar AS Form
*: 
*: 		Class     CLabel AS Label
*:
*: (c) Piva, BEAR v.42 on 04.04.2003 10:44
*:********************************************************************
*
* Yet Another One Calendar
*
*   .. 2003, piva@kurgan.isp.ru
* 17:00, 3  2003 .
*
* m.Obj   textbox     
* x,y -  x, y
*

#define BASE	25
#define C_STEP	22

#define CAL_THAT_NORM_COLOR	Rgb(0,0,0)
#define CAL_THAT_REST_COLOR	Rgb(255,0,0)

#define CAL_OUT_NORM_COLOR	Rgb(192,192,192)
#define CAL_OUT_REST_COLOR	Rgb(255,192,192)

#define CAL_BACK_COLOR		Rgb(255,255,255)

#define CAL_MONTH_COLOR		Rgb(0,0,0)
#define CAL_YEAR_COLOR		Rgb(0,0,0)
#define CAL_TODAY_COLOR		Rgb(0,0,128)

#define CAL_LEFT_COLOR		Rgb(0,0,0)
#define CAL_RIGHT_COLOR		Rgb(0,0,0)

#define CAL_MARK_COLOR		Rgb(255,0,0)

Lparameters m.Obj, x, y

If Vartype(_FontName)='U'
	_FontName='Tahoma'
EndIf

Local l,t,h
t=Objtoclient(_Screen.ActiveForm,1)		&&   Top
l=Objtoclient(_Screen.ActiveForm,2)		&&   Left
h=0

With _screen.ActiveForm
	If .TitleBar>0				&&  
		If .HalfheightCaption	&&   
			t=t+Sysmetric(34)
		Else
			t=t+Sysmetric(9)
		EndIf
	EndIf
	DO case
	Case .BorderStyle=0			&&  
	Case .BorderStyle=1			
		t=t+Sysmetric(11)		&&  ?
		l=l+Sysmetric(10)
	Case .BorderStyle=2			&& Nonsizable
		t=t+Sysmetric(11)
		l=l+Sysmetric(10)
	Case .BorderStyle=3			&& sizeable
		t=t+Sysmetric(4)
		l=l+Sysmetric(3)
	EndCase
EndWith

Local oCal,ret
If Vartype(m.Obj)="O"
	Ret=m.Obj.Value
Else
	Ret={}
EndIf
oCal=CreateObject("Calendar",Ret)
With oCal
	
	If Vartype(x)='N' and Vartype(y)='N'
		*    -   
		.Top=y
		.Left=x
	Else
		.Top=t
		.Left=l
		
		If Vartype(m.Obj)='O'
			.Top=.Top+m.Obj.Top+m.Obj.Height
			.Left=.Left+m.Obj.Left
		EndIf
		
		If .Top+.Height > Sysmetric(2)
			.Top=Sysmetric(2)-.Height
		EndIf
		If .Left+.Width > Sysmetric(1)
			.Left=Sysmetric(1)-.Width
		EndIf
		If .Top < 0
			.Top=1
		EndIf
		If .Left < 0
			.Left=1
		EndIf
	EndIf

	.Show(1)
	
	If not Empty(.Value)
		If Vartype(m.Obj)="O"
			m.Obj.Value=.Value
		EndIf
		Ret=.Value
	EndIf
EndWith
Return Ret

*:********************************************************************
*:
*:    Class : CALENDAR based on FORM
*:
*:********************************************************************
Define Class Calendar as Form
	FontName='Arial'	&&   !!!
	FontSize=8
	MinButton=.F.
	MaxButton=.F.
	BorderStyle=2
	TitleBar=0
	Caption=""
	Width=160
	Height=200
	DeskTop=.T.
	BackColor=CAL_BACK_COLOR
	
	Dimension Dates[6,7]
	Dimension Days[7]
	
	Date={}
	Value={}
	
	RestDays='6,7'	&&    -6,  - 7
	
	Add Object Line1 as Line with ;
		Left=1,;
		Top=BASE+16,;
		Width=160,;
		Height=0
	
	Add Object Line2 as Line with ;
		Left=1,;
		Top=BASE+150,;
		Width=160,;
		Height=0
	
	Add Object lMonth as Label with ;
		Top=5,;
		Left=30,;
		AutoSize=.T.,;
		FontName=_FontName,;
		FontSize=8,;
		FontBold=.T.,;
		BackStyle=0,;
		ForeColor=CAL_MONTH_COLOR
	
	Add Object lYear as Label with ;
		Top=5,;
		Left=100,;
		AutoSize=.T.,;
		FontName=_FontName,;
		FontSize=8,;
		FontBold=.T.,;
		BackStyle=0,;
		ForeColor=CAL_YEAR_COLOR
	
	Add Object lToDay as Label with ;
		Alignment=2,;
		Top=180,;
		Left=0,;
		Width=160,;
		FontName=_FontName,;
		FontSize=8,;
		FontBold=.T.,;
		BackStyle=0,;
		ForeColor=CAL_TODAY_COLOR

	
	Add Object Mark as Shape with ;
		Width=22,;
		Height=22,;
		BackStyle=0,;
		BorderStyle=1,;
		BorderWidth=2,;
		BorderColor=CAL_MARK_COLOR,;
		Curvature=99
	
	Add Object cmd1 as LabeL with ;
		Top=5,;
		Left=5,;
		Width=16,;
		Height=16,;
		FontName='Marlett',;
		FontSize=10,;
		Caption='3',;
		TabStop=.F.,;
		BackStyle=0,;
		ForeColor=CAL_LEFT_COLOR
		
	
	Add Object cmd2 as LabeL with ;
		Top=5,;
		Left=145,;
		Width=16,;
		Height=16,;
		FontName='Marlett',;
		FontSize=10,;
		Caption='4',;
		TabStop=.F.,;
		BackStyle=0,;
		ForeColor=CAL_RIGHT_COLOR
		
	
	*:********************************************************************
	*:
	*: Method : INIT of class CALENDAR
	*:
	*:********************************************************************
	Procedure Init(tDate)
	With this
		Declare integer GetUserDefaultLCID in win32api
		Declare Integer GetDateFormat in Win32Api ;
			Integer LCID ,;
			Integer dwFlags,;
			String SystemDate ,;
			String lpFormat,;
			String @ lpDateStr,;
			Integer lenDate 
		
		Local lRest
		lRest=.RestDays
		
		tDate=Iif(Empty(tDate),{},tDate)
		.Value=tDate
		.Date=Iif(Empty(tDate),Date(),tDate)
		.lToDay.Caption=DateFormat(Date(),'d MMMM yyyy')


		
		.Comment=On("KEY","LEFTMOUSE")
		On Key Label LeftMouse _Screen.ActiveForm.OnMouse
		For i=1 to 7
			tDate={^1900.01.01}+i-1
			cName='.Days[i]'
			.AddObject(cName,'CLabel')
			With .Days[i]
				.Caption=DateFormat(tDate,'ddd')
				If InList(Dow(tDate,2),&lRest)
					.ForeColor=CAL_THAT_REST_COLOR
				Else
					.ForeColor=CAL_THAT_NORM_COLOR
				EndIf
				.Left=(i-1)*C_STEP+2
			EndWith
		Next
		For r=1 to 6
			For w=1 to 7
				cName='.Dates[r,w]'
				.AddObject(cName,'CLabel')
				With .Dates[r,w]
					.Caption=''
					.Left=(w-1)*C_STEP+2
					.Top=20*(r)+BASE+10
				EndWith
			Next
		Next
		.Requery()
	EndWith			
	
	*:********************************************************************
	*:
	*: Method : DESTROY of class CALENDAR
	*:
	*:********************************************************************
	Procedure Destroy
	With this
		Local s
		s=.Comment
		On Key Label LeftMouse &s
	EndWith
	
	*:********************************************************************
	*:
	*: Method : REQUERY of class CALENDAR
	*:
	*:********************************************************************
	Procedure ReQuery
	With this
		.LockScreen=.T.
		.lMonth.Caption=DateFormat(.Date,'MMMM')
		.lYear.Caption=DateFormat(.Date,'yyyy')
		
		Local BaseDate,i,r,w
		lRest=.RestDays
		BaseDate=.Date-Day(.Date)+1
		BaseDate=BaseDate-Dow(BaseDate,2)+1
		
		i=0
		For r=1 to 6
			For w=1 to 7
				i = i + 1 
				With .Dates[r,w]
					.Date=BaseDate-1+i
					.Caption=Transform(Day(.Date),'99')
					If Month(.Date)=Month(This.Date)
						.ForeColor=CAL_THAT_NORM_COLOR
						If InList(Dow(.Date,2),&lRest)
							.ForeColor=CAL_THAT_REST_COLOR
						EndIf
					Else
						.ForeColor=CAL_OUT_NORM_COLOR
						If InList(Dow(.Date,2),&lRest)
							.ForeColor=CAL_OUT_REST_COLOR
						EndIf
					EndIf
					If .Date=This.Date
						This.SetMark(This.Dates[r,w])
					EndIf
				EndWith
			Next
		Next
		.LockScreen=.F.
	EndWith
	
	*:********************************************************************
	*:
	*: Method : SETMARK of class CALENDAR
	*:
	*:********************************************************************
	Procedure SetMark(o)
	With this.Mark
		.Top=o.Top-5
		.Left=o.Left
	EndWith
	
	*:********************************************************************
	*:
	*: Method : KEYPRESS of class CALENDAR
	*:
	*:********************************************************************
	Procedure KeyPress(nKeyCode, nShiftAltCtrl)
	With this
		DO Case
		Case nKeyCode=19 && Left
			.Date=.Date-1
		Case nKeyCode=4 && Right
			.Date=.Date+1
		Case nKeyCode=5 && Up
			.Date=.Date-7
		Case nKeyCode=24 && Down
			.Date=.Date+7
		Case nKeyCode=18 && Pg Up
			.Date=Gomonth(.Date,-1)
		Case nKeyCode=3 && Pg Down
			.Date=Gomonth(.Date,1)
		Case nKeyCode=31 && Ctrl + Pg Up
			.Date=Gomonth(.Date,-12)
		Case nKeyCode=30 && Ctrl + Pg Down
			.Date=Gomonth(.Date,12)
		Case nKeyCode=13
			.Value=.Date
			.Hide
			.Release
		Case nKeyCode=27
			.Hide
			.Release
		Otherwise
			Return .T.
		EndCase
		.Requery()
	EndWith
	
	*:********************************************************************
	*:
	*: Method : LTODAY.CLICK of class CALENDAR
	*:
	*:********************************************************************
	Procedure lToDay.Click
	With thisform
		.Date=Date()
		.Requery()
	EndWith
	
	*:********************************************************************
	*:
	*: Method : LTODAY.DBLCLICK of class CALENDAR
	*:
	*:********************************************************************
	Procedure lToDay.DblClick
	With thisform
		.Value=.Date
		.Hide
		.Release
	EndWith
	
	*:********************************************************************
	*:
	*: Method : LMONTH.CLICK of class CALENDAR
	*:
	*:********************************************************************
	Procedure lMonth.Click
	With thisform
		Local m.Date, m.Bar
		m.Date={^1900.01.01}
		*    !!!  Arial,8
		Define Popup Cal from 1.500,0.500 Margin Relative ShortCut
		For i=1 to 12
			Define Bar i of Cal Prompt DateFormat(Gomonth(m.Date,i-1),'MMMM')
		Next
		On Selection Popup Cal Deactivate Popup
		On Key Label LeftMouse
		Activate Popup Cal Bar (Month(.Date))
		On Key Label LeftMouse _Screen.ActiveForm.OnMouse
		
		m.Bar=Bar()
		Release Popup Cal
		If m.Bar > 0
			.Date=Date(Year(.Date),m.Bar,Day(.Date))
			.ReQuery()
		EndIf
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : LYEAR.CLICK of class CALENDAR
	*:
	*:********************************************************************
	Procedure lYear.Click
	With thisform
		Local m.Year, m.Bar
		m.Year=Year(.Date)
		*    !!!  Arial,8
		Define Popup Cal from -6.500,15.500 Margin Relative ShortCut
		For i=m.Year-5 to m.Year+5
			Define Bar i of Cal Prompt Transform(i,'9999')
		Next
		On Selection Popup Cal Deactivate Popup
		On Key Label LeftMouse
		Activate Popup Cal
		On Key Label LeftMouse _Screen.ActiveForm.OnMouse
		
		m.Bar=Bar()
		Release Popup Cal
		If m.Bar > 0
			.Date=Date(m.Bar,Month(.Date),Day(.Date))
			.ReQuery()
		EndIf
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : CMD1.CLICK of class CALENDAR
	*:
	*:********************************************************************
	Procedure Cmd1.Click
	ThisForm.keyPress(3,0)
	
	*:********************************************************************
	*:
	*: Method : CMD2.CLICK of class CALENDAR
	*:
	*:********************************************************************
	Procedure Cmd2.Click
	ThisForm.keyPress(18,0)
	
	*:********************************************************************
	*:
	*: Method : ONMOUSE of class CALENDAR
	*:
	*:********************************************************************
	Procedure OnMouse
	Local tmp[1], k
	k=AMouseObj(tmp)
	If Vartype(tmp[2])='O'
		If Compobj(tmp[2],thisform)
			Return .T.		
		Else
			This.Hide
			This.Release
		EndIf
	EndIf
	This.Hide
	This.Release
	
EndDefine


*:********************************************************************
*:
*:    Class : CLABEL based on LABEL
*:
*:********************************************************************
Define Class CLabel as Label
	Top=BASE
	Alignment=2
	BackStyle=0
	FontName=_FontName
	FontSize=8
	Width=20
	Visible=.T.	
	Date={}
	
	*:********************************************************************
	*:
	*: Method : CLICK of class CLABEL
	*:
	*:********************************************************************
	Procedure Click
	With this
		If not Empty(.Date)
			If Month(.Date) # Month(.Parent.Date)
				.Parent.Date=.Date
				.Parent.Requery
			Else
				.Parent.SetMark(This)
			EndIf
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : DBLCLICK of class CLABEL
	*:
	*:********************************************************************
	Procedure DblClick
	With this
		If not Empty(.Date)
			If Month(.Date) = Month(.Parent.Date)
				.Parent.Value=.Date
				.Parent.Hide
				.Parent.Release
			EndIf
		EndIf
	EndWith
EndDefine

*:********************************************************************
*:
*: Procedure : DATEFORMAT
*:
*:********************************************************************
Procedure DateFormat(m.date, m.cFormat)
if empty(m.date)
	Return ""
endif
if empty(m.cFormat)
	m.cFormat='dd.MM.yyyy'
endif

local struct, buf, l
struct=;
	(SWord(Year(m.Date));
	+SWord(Month(m.Date));
	+SWord(1);
	+SWord(Day(m.Date));
	+SWord(0);
	+Sword(0);
	+SWord(0);
	+SWord(0);
	+SWord(0);
	)

buf=repl(chr(0),128)
l=GetDateFormat(GetUserDefaultLCID(),0,struct,m.cFormat,@buf,len(buf))
if l > 1
	Return Left(buf,l-1)
endif
Return ""

*:********************************************************************
*:
*: Procedure : SWORD
*:
*:********************************************************************
Procedure SWORD( m.Int )
Return Chr(Mod(m.Int,256))+Chr(Int(m.Int/256))
*: End of CALENDAR.PRG
