*
*   
*
* 10:11, 5  2003 .
*   .. 2003, piva@kurgan.isp.ru
*

#include Main.h

***************************************************************************
*
*							 Supply
*
***************************************************************************
Procedure DataSupIn
Parameters m.oDoc

Local x, o, m.Alias
Private m.Total, m.NdsSum

*
*    
*

m.Alias=(m.oDoc.Data.TmpAlias)
m.Total=0
m.NdsSum=0

Select ;
	Item.ItemID;
	,Padr(Item.Name,50) As Sort ;
	,Item.Name;
	,Item.unit;
	,Item.Nds;
	,Item.Tax ;
	,$0 As Amount ;
	,$0 As Price ;
	,$0 As Cost ;
	,$0 As Remainder ;
	,$0 As NDSSUM ;
	,$0 As TaxSUM ;
	,$0 As Summa ;
	,$0 As Batch ;
	,$0 As oAmount ;
	from Item ;
	where Not Item.Excluded ;
	and Not Item.UnLimited ;
	order By 2 ;
	into Cursor _DataSupIn_ Readwrite

Index On ItemID Tag ItemID
Set Order To Tag 0

Select (m.Alias)
Scan All
	m.ItemID=ItemID
	Scatter Memo Name o
	m.Total = m.Total + (Amount*Price)
	Select _DataSupIn_
	Locate For ItemID=m.ItemID
	If Found()
		Gather Memo Name o
	Endif
Endscan

Select _DataSupIn_

x=Createobject("DataSupIn")
x.Show(1)

Select (m.Alias)
If Used(m.Alias)
	Zap In (m.Alias)
Endif

Select _DataSupIn_
Scan All For Not Empty(Summa)
	Scatter Memo Name o
	Select (m.Alias)
	Append Blank
	Gather Memo Name o
Endscan

Use In _DataSupIn_
Select (m.Alias)

m.oDoc.Record.Total=m.Total

Define Class DataSupIn As StatusBarView
	Caption=" "
	CLSID="DataSupIn.View.1"
	Total=0
	NdsSum=0
	TmpVal=0

	Procedure Init
	With This
		DoDefault()

		With .StatusBar
			.AddPanel(1,"",300)
			.AddPanel(2,"",50)
			.AddPanel(3,"",120,1)
			.AddPanel(4,"",12)

			.Panels[3].Text.FontBold=.T.
			.Panels[3].Text.ToolTipText="  "
			.Panels[3].Text.Caption=Transform(m.Total,_PIC_TOTAL)

		Endwith

		With .Grid
			.RecordSource='_DataSupIn_'
			.AddColumn(1,"(Name)","",3,"Name")
			.AddColumn(2,"(Unit)","..")
			.AddColumn(3,"Price","",'@Z '+_PIC_PRICE)
			.AddColumn(4,"Amount","-",'@Z '+_PIC_AMOUNT)
			.AddColumn(5,"Remainder","",'@Z '+_PIC_AMOUNT)
			.AddColumn(6,"Summa","",'@Z '+_PIC_SUMMA)
			.AddColumn(7,"NDSSum"," ",'@Z '+_PIC_SUMMA)
			.AddColumn(8,"NDS"," ",'@Z '+_PIC_PERCENT)

			.Columns[3].Text.ValidProcedure="ThisForm.ValidPrice()"

			.Columns[4].Text.WhenProcedure="ThisForm.WhenAmount()"
			.Columns[4].Text.ValidProcedure="ThisForm.ValidAmount()"

			.Columns[6].Text.ValidProcedure="ThisForm.ValidSumma()"

			.Columns[2].Enabled=.F.
			.Columns[5].Enabled=.F.
			.Columns[7].Enabled=.F.
			.Columns[8].Enabled=.F.

			.ReadOnly=.F.

			.AllowCellSelection=.T.
*!*				.HighlightBackColor=ThisForm.BackColor
*!*				.HighlightForeColor=ThisForm.ForeColor

		Endwith

		.Total=m.Total

		.RestoreView()
		.Resize()

	Endwith

	Procedure ValidPrice
	With This
		.Calculate()
	Endwith

	Procedure WhenAmount
	With This
		.TmpVal=Amount
	Endwith

	Procedure ValidAmount
	With This
		If Not Empty(Batch)
			If Amount < (oAmount-Remainder)
				Messagebox("c       ",64,.Caption)
				Replace Amount With .TmpVal
				Return 0
			Endif
			Replace Remainder With Remainder+(Amount-.TmpVal)
		Else
			Replace Remainder With Amount
		Endif
		.Calculate()
	Endwith

	Procedure ValidSumma
	With This
		.Calculate(1)
	Endwith

	Procedure Calculate(lBack)
	With This

		If Not Empty(lBack)
			Replace NDSSUM With Round(Summa*Nds/(100+Nds),_TAX_ROUND)
			If Not Empty(Amount)
				Replace Price With Round(Summa/Amount,_ROUND)
			Endif
		Endif

		If Empty(lBack)
			Replace Summa 	With Amount*Price
			Replace NDSSUM	With Round(Summa*Nds/(100+Nds),_TAX_ROUND)

			If Not Empty(Amount)
				Replace Cost 	With Round((Summa-NDSSUM)/Amount,_ROUND)
			Endif
		Endif

		Local tmp[1]
		Select Sum(Summa),Sum(NdsSum) From _DataSupIn_ Into Array tmp
		.NdsSum=Iif(_Tally=0,0,tmp[2])
		.Total=Iif(_Tally=0,0,tmp[1])

	Endwith

	Procedure Total_Assign(m.Value)
	With This
		.Total=m.Value
		m.Total=.Total
		m.NdsSum=.NdsSum
		.StatusBar.Panels[3].Text.Caption=Transform(.Total,_PIC_TOTAL)
	Endwith

Enddefine


***************************************************************************
*
*							 Invoice
*
***************************************************************************
Procedure DataInvIn
Parameters m.oDoc

Local x, o, m.Aalias, m.DocId, m.Caption, m.PriceType, m.ItemPrice
Private m.Total, m.NdsSum

*
*    
*
m.Caption=' '

If Vartype(m.oDoc.Form)='O'
	m.Caption=m.oDoc.Form.Caption
Endif

m.PriceType=m.oDoc.Record.PriceType
m.DocId=m.oDoc.Record.DocId
m.Alias=m.oDoc.Data.TmpAlias
m.Total=0
m.NdsSum=0

If Empty(m.PriceType)
	m.PriceType=1
Endif

m.ItemPrice='ITEM.PRICE'+Num(m.PriceType)

Select ;
	Item.ItemID;
	,Item.GroupID ;
	,Padr(Part.Name,20) As PartName ;
	,Padr(Item.Name,50) As ItemName ;
	,Item.Name;
	,Item.unit;
	,Item.Nds;
	,Item.Tax ;
	,$0 As Amount ;
	,$0 As Amount2 ;
	,&ItemPrice As Price ;
	,$0 As Cost ;
	,SupData.Remainder As Remainder ;
	,$0 As Remainder2 ;
	,$0 As NDSSUM ;
	,$0 As TaxSUM ;
	,$0 As Summa ;
	,$0 As oAmount ;
	,$0 As oAmount2 ;
	,SupData.Batch ;
	,SupData.Price As BatchPrice ;
	,SupData.Ship ;
	,Item.MinPrice ;
	from SupData, Supply, Item, Part ;
	where Supply.DocId=SupData.DocId ;
	and SupData.Remainder > 0 ;
	and Not Supply.DocType=SUP_RESERVED ;
	and Item.ItemID=SupData.ItemID ;
	and Part.GroupID=Item.GroupID ;
	and Not Item.Excluded ;
	and Not Item.UnLimited ;
	order By PartName,ItemName ;
	into Cursor _DataInvIn_ Readwrite


Index On ItemID Tag ItemID
Index On Batch  Tag Batch
Set Order To Tag 0

Replace All Price With MinPrice For Price < MinPrice
Replace All Price With BatchPrice+Ship For Price < BatchPrice+Ship

Select (m.Alias)
Scan All
	m.lAdd=.F.
	m.ItemID=ItemID
	m.Batch=Batch

	Scatter Memo Name o

	m.Total = m.Total + (Amount*Price)

	Select _DataInvIn_
	If Seek(m.Batch,"_DataInvIn_","Batch")
		m.lAdd=.T.
	Else
		If Seek(m.ItemID,'ITEM','ITEMID')
			If Seek(Item.GroupID,'PART','GROUPID')
				If Seek(m.Batch,'SUPDATA','BATCH')
					Append Blank
					Replace ItemID		With m.ItemID,;
						GroupID		With Part.GroupID,;
						ItemName 	With Padr(Item.Name,50),;
						PartName	With Padr(Part.Name,50),;
						Batch		With m.Batch,;
						Remainder	With SupData.Remainder,;
						BatchPrice	With SupData.Price

					m.lAdd=.T.

				Endif
			Endif
		Endif
	Endif
	If m.lAdd
		Gather Memo Name o
	Endif

Endscan

Select * From InvData Where DocId=m.DocId Into Cursor _
Scan All
	If Not Empty(_.Batch) And Seek(_.Batch,"_DataInvIn_","Batch")
		Replace _DataInvIn_.Remainder With _DataInvIn_.Remainder+_.Amount
	Endif
Endscan

Select _DataInvIn_

x=Createobject("DataInvIn")
x.Caption=m.Caption

Push Menu _MSYSMENU 

Define Popup DataIn margin relative 
Define Pad DataIn of _MSYSMENU Prompt "" skip for DataInvPopup()
On Pad DataIn of _msysmenu activate popup DataIn
On Selection Popup DataIn do DatainvPopupSelection with Bar()

x.Show(1)

Pop Menu _MSYSMENU 

Select (m.Alias)
If Used(m.Alias)
	Zap In (m.Alias)
Endif

Select _DataInvIn_
Scan All For Not Empty(Summa)
	Scatter Memo Name o
	Select (m.Alias)
	Append Blank
	Gather Memo Name o
Endscan

Use In _DataInvIn_
Select (m.Alias)

m.oDoc.Record.Total=m.Total
m.oDoc.Record.NdsSum=m.NdsSum


Define Class DataInvIn As StatusBarView
	Caption=" "
	CLSID="DataInvIn.View.1"
	Total=0
	NdsSum=0
	TmpVal=0
	Alias="_DataInvIn_"
	FaceMask=FACE_MODAL

	Procedure Init
	With This
		DoDefault()

		With .StatusBar
			.AddPanel(1,"",300)
			.AddPanel(2,"",50)
			.AddPanel(3,"",120,1)
			.AddPanel(4,"",12)

			.Panels[3].Text.FontBold=.T.
			.Panels[3].Text.ToolTipText="  "
			.Panels[3].Text.Caption=Transform(m.Total,_PIC_TOTAL)

		Endwith

		Select (.Alias)
		With .Grid
			.RecordSource=This.Alias
			.AddColumn( 1,"(Name)","",3,"Name")
			.AddColumn( 2,"(Unit)","..")
			.AddColumn( 3,"Price","",'@Z '+_PIC_PRICE)
			.AddColumn( 4,"Amount","-",'@Z '+_PIC_AMOUNT)
			.AddColumn( 5,"Amount2","- 2",'@Z '+_PIC_AMOUNT)
			.AddColumn( 6,"Remainder","",'@Z '+_PIC_AMOUNT)
			.AddColumn( 7,"Remainder2"," 2",'@Z '+_PIC_AMOUNT)
			.AddColumn( 8,"Summa","",'@Z '+_PIC_SUMMA)
			.AddColumn( 9,"NDSSum"," ",'@Z '+_PIC_SUMMA)
			.AddColumn(10,"NDS"," ",'@Z '+_PIC_PERCENT)

			.Columns[ 3].Text.ValidProcedure="ThisForm.ValidPrice()"

			.Columns[ 4].Text.WhenProcedure="ThisForm.WhenAmount(1)"
			.Columns[ 4].Text.ValidProcedure="ThisForm.ValidAmount(1)"
			.Columns[ 5].Text.WhenProcedure="ThisForm.WhenAmount(2)"
			.Columns[ 5].Text.ValidProcedure="ThisForm.ValidAmount(2)"

			.Columns[ 8].Text.ValidProcedure="ThisForm.ValidSumma()"

			.Columns[ 2].Enabled=.F.
			.Columns[ 6].Enabled=.F.
			.Columns[ 7].Enabled=.F.
			.Columns[ 9].Enabled=.F.
			.Columns[10].Enabled=.F.

			.AllowCellSelection=.T.
			.ReadOnly=.F.

		Endwith

		.Total=m.Total

		Aspect(this)
		.RestoreView()
		.Resize()

	Endwith

	Procedure ValidPrice
	With This
		If Price < MinPrice And Messagebox("    "+Price(MinPrice),1+64+256,.Caption) # 1
			Return 0
		Endif
		If Price < BatchPrice+Ship And Messagebox("   "+Price(BatchPrice+Ship),1+64+256,.Caption) # 1
			Return 0
		Endif
		If Price < BatchPrice And Messagebox("   "+Price(BatchPrice),1+64+256,.Caption) # 1
			Return 0
		Endif
		.Calculate()
	Endwith

	Procedure WhenAmount(nWhat)
	With This
		Do Case
		Case nWhat=1
			.TmpVal=Amount
		Case nWhat=2
			.TmpVal=Amount2
		Endcase
	Endwith

	Procedure ValidAmount(nWhat)
	With This
		If Not Empty(Batch)
			m.Amount=0
			Do Case
			Case nWhat=1
				If Amount > Remainder
					Messagebox("c   "+Amount(Remainder),64,.Caption)
					Replace Amount With .TmpVal
					Return 0
				Endif
			Case nWhat=2
				If Amount2 > Remainder2
					Messagebox("c 2   "+Amount(Remainder2),64,.Caption)
					Replace Amount2 With .TmpVal
					Return 0
				Endif
			Endcase
		Endif
		.Calculate()
	Endwith

	Procedure ValidSumma
	With This
		.Calculate(1)
	Endwith

	Procedure Calculate(lBack)
	With This

		If Not Empty(lBack)
			Replace NDSSUM With Round(Summa*Nds/(100+Nds),_TAX_ROUND)
			If Not Empty(Amount)
				Replace Price With Round(Summa/(Amount+Amount2),_ROUND)
			Endif
		Endif

		If Empty(lBack)
			Replace Summa 	With Amount*Price
			Replace NDSSUM	With Round(Summa*Nds/(100+Nds),_TAX_ROUND)

			If Not Empty(Amount)
				Replace Cost 	With Round((Summa-NDSSUM)/(Amount+Amount2),_ROUND)
			Endif
		Endif

		Local tmp[1]
		Select Sum(Summa),Sum(NdsSum) From (.Alias) Into Array tmp
		.NdsSum=Iif(_Tally=0,0,tmp[2])
		.Total=Iif(_Tally=0,0,tmp[1])

	Endwith

	Procedure Total_Assign(m.Value)
	With This
		.Total=m.Value
		m.Total=.Total
		m.NdsSum=.NdsSum
		.StatusBar.Panels[3].Text.Caption=Transform(.Total,_PIC_TOTAL)
	Endwith

Enddefine

Procedure DataInvPopup(lNull)

Define Bar 1 of DataIn Prompt "One"
Define Bar 2 of DataIn Prompt "Two"
Define Bar 3 of DataIn Prompt "Three"
Define Bar 4 of DataIn Prompt "Four"

Return .F.


Procedure DataInvPopupSelection(nBar)
MessageBox("Selected "+num(nBar))



