*
*  -  
*   
* 	PART - 
*	ITEM - 
*
*   .. 2003, piva@kurgan.isp.ru
* 13:13, 13  2003 .
*

***********************************************
*  Storage
*
* ()  .. 2003
* 13  2003 . 15:40
***********************************************

#include include/main.h

*External Form Storage
External Form Item
External Form Part


ROOT_OBJECT.AddObject("STORAGE","STORAGE")
ROOT_OBJECT.AddObject("PART","PART")
ROOT_OBJECT.AddObject("ITEM","ITEM")

Define Class Storage as Document
	Title=''
	ListClsID='Storage.View.1'
	ListCaption=' '
	KeyField='DOCID'
	

	Procedure Title_Access
	With this
		If ROOT_OBJECT.Operation=OP_LIST
			Return ""
		Else
			Return ""
		EndIf
	EndWith

	Procedure List
	With this
		If Vartype(.ListForm) # "O"
			.ListForm=NewObject("Storage","DualView.PRG","",'part','item')
		EndIf
		.ListForm.show()
	EndWith
	
EndDefine 


***********************************************
*  Item
*
* ()  .. 2003
* 13  2003 . 15:41
***********************************************


Define Class Item as Document
	Title=''
	Alias='Item'
	FormName='Item'
	ListClsID='Item.View.1'
	ListCaption=' '
	KeyField='ITEMID'
	Name="ITEM"
	FaceMask=FACE_10
	
	Procedure Default
	With this.record
	EndWith 
	
	Procedure Tested
	With this.record
		If Empty(.Name)
			MessageBox("   ",64,this.title)
			Return .F.
		EndIf
	EndWith 

	Procedure Grid(oGrid)
	With oGrid
		.ChildOrder='SORT'
		.RelationalExpr='GROUPID'
		.LinkMaster=.Parent.Parent.Parent.TreeAlias

		.AddColumn(1,"(Name)","",3)
		.AddColumn(2,"(Unit)",".")
		.AddColumn(3,"(Packing)","")
		.AddColumn(4,"Price1"," 1","@Z "+_PIC_PRICE)
		.AddColumn(5,"Price2"," 2","@Z "+_PIC_PRICE)
		.AddColumn(6,"Price3"," 3","@Z "+_PIC_PRICE)
		.AddColumn(7,"Price4"," 4","@Z "+_PIC_PRICE)
		.AddColumn(8,"Price5"," 5","@Z "+_PIC_PRICE)
	EndWith

	Procedure Title_Access
	With this
		If ROOT_OBJECT.Operation=OP_LIST
			Return ""
		Else
			Return .Title
		EndIf
	EndWith

	Procedure Packing
	* Make Packing
	With this
		Local ret
		ret="1"
		If not Empty(.record.pack)
			ret=ret+"x"+Alltrim(Transform(.record.pack,_PIC_AMOUNT))
		EndIf
		If not Empty(.record.box)
			ret=ret+"x"+Alltrim(Transform(.record.box,_PIC_AMOUNT))
		EndIf
		.Record.Packing=ret
		If Vartype(.Form)="O"
			.Form.Refresh
		EndIf
	EndWith

	Procedure MyDelete
	With this
		If not Empty(.Record.ItemID)
			Local tmp[1]
			
			Select Count(*) ;
				from SupData,Supply ;
				where SupData.ItemID=.Record.ItemID ;
				and Supply.DocID=SupData.DocID ;
				into array tmp

			If TMP[1] > 0
				MessageBox('  "'+Alltrim(.Record.Name)+'" ,      .',48,.Title)
				Return .F.
			EndIf

			Select Count(*) ;
				from InvData,Invocie ;
				where InvData.ItemID=.Record.ItemID ;
				and Invoice.DocID=Invocie.DocID ;
				into array tmp

			If _TALLY > 0
				MessageBox('  "'+Alltrim(.Record.Name)+'" ,      .',48,.Title)
				Return .F.
			EndIf

		EndIf
	EndWith

EndDefine 

***********************************************
*  Part
*
* ()  .. 2003
* 13  2003 . 15:41
***********************************************


Define Class Part as Document
	Title=''
	Alias='Part'
	FormName='Part'
	ListClsID='Part.View.1'
	ListCaption=' '
	KeyField='GROUPID'
	Name="PART"
	
	Procedure Default
	With this.record

	EndWith 
	
	Procedure Tested
	With this.record
		If Empty(.Name)
			MessageBox("   ",64,this.title)
			Return .F.
		EndIf
	EndWith 

	Procedure Grid(oGrid)
	With oGrid
		.AddColumn(1,"(Name)","",3,"Name")
	EndWith

	Procedure Title_Access
	With this
		If ROOT_OBJECT.Operation=OP_LIST
			Return ""
		Else
			Return .Title
		EndIf
	EndWith

	Procedure MyDelete
	With this
		If not Empty(.Record.GroupID)
			Local m.GroupID,tmp[1]
			
			Select Count(*) from item where GroupID=.Record.GroupID into array tmp
			If tmp[1] > 0
				MessageBox('  "'+Alltrim(.Record.Name)+'" ,     .',48,.Title)
				Return .F.
			EndIf

		EndIf
	EndWith


EndDefine 